Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/instruction.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/instruction.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/instruction.h	(revision 16332)
@@ -0,0 +1,45 @@
+#ifndef INSTRUCTION_H
+#define INSTRUCTION_H
+
+#include <cstdint>
+
+#include "vector_operations.h"
+
+enum OpCodes : uint8_t
+{
+    // same values as in OpCodes.cs
+    Add = 1,
+    Sub = 2,
+    Mul = 3,
+    Div = 4,
+    Sin = 5,
+    Cos = 6,
+    Tan = 7,
+    Log = 8,
+    Exp = 9,
+    Var = 18,
+    Const = 20,
+    Power = 22,
+    Root = 23,
+    Square = 28,
+    Sqrt = 29
+};
+
+struct instruction
+{
+    // from Instruction.cs
+    uint8_t opcode;
+    uint16_t narg;
+
+    int childIndex;
+
+    // from LinearInstruction.cs
+    double value;
+    double weight; // necessary for variables
+
+    // pointer to data
+    double *buf;
+    double *data;
+};
+
+#endif
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp	(revision 16332)
@@ -0,0 +1,63 @@
+#include "interpreter.h" 
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+constexpr size_t BUFSIZE = BATCHSIZE * sizeof(double);
+
+// slow (ish?)
+__declspec(dllexport) 
+double __cdecl GetValue(instruction* code, int codeLength, int row) noexcept
+{
+    return evaluate(code, codeLength, row);
+}
+
+__declspec(dllexport) 
+void __cdecl GetValues(instruction* code, int codeLength, int* rows, int totalRows, double* result) noexcept
+{
+    for (int i = 0; i < totalRows; ++i)
+    {
+        result[i] = evaluate(code, codeLength, rows[i]);
+    }
+}
+
+__declspec(dllexport)
+void __cdecl GetValuesVectorized(instruction* code, int codeLength, int* rows, int totalRows, double* __restrict result) noexcept
+{
+    double* buffer = static_cast<double*>(_aligned_malloc(codeLength * BUFSIZE, 16));
+    for (int i = 0; i < codeLength; ++i)
+    {
+        instruction& in = code[i];
+        in.buf = buffer + (i * BATCHSIZE);
+
+        if (in.opcode == OpCodes::Const)
+        {
+            load(in.buf, in.value);
+        }
+    }
+
+    int remainingRows = totalRows % BATCHSIZE;
+    int total = totalRows - remainingRows;
+
+    for (int rowIndex = 0; rowIndex < total; rowIndex += BATCHSIZE)
+    {
+        evaluate(code, codeLength, rows, rowIndex, BATCHSIZE);
+        std::memcpy(result + rowIndex, code[0].buf, BUFSIZE);
+    }
+
+    // are there any rows left?
+    if (remainingRows > 0) 
+    {
+        for (int rowIndex = total; rowIndex < totalRows; rowIndex += remainingRows)
+        {
+            evaluate(code, codeLength, rows, rowIndex, remainingRows);
+            std::memcpy(result + rowIndex, code[0].buf, remainingRows * sizeof(double));
+        }
+    }
+    _aligned_free(buffer);
+}
+
+#ifdef __cplusplus
+}
+#endif
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h	(revision 16332)
@@ -0,0 +1,231 @@
+#ifndef NATIVE_TREE_INTERPRETER_CLANG_H
+#define NATIVE_TREE_INTERPRETER_CLANG_H
+
+#include "vector_operations.h"
+#include "instruction.h"
+
+inline double evaluate(instruction *code, int len, int row) noexcept
+{
+    for (int i = len - 1; i >= 0; --i)
+    {
+        instruction &in = code[i];
+        switch (in.opcode)
+        {
+            case OpCodes::Var:
+                {
+                    in.value = in.weight * in.data[row];
+                    break;
+                }
+            case OpCodes::Add:
+                {
+                    in.value = code[in.childIndex].value;
+                    for (int j = 1; j < in.narg; ++j)
+                    {
+                        in.value += code[in.childIndex + j].value;
+                    }
+                    break;
+                }
+            case OpCodes::Sub:
+                {
+                    in.value = code[in.childIndex].value;
+                    for (int j = 1; j < in.narg; ++j)
+                    {
+                        in.value -= code[in.childIndex + j].value;
+                    }
+                    if (in.narg == 1)
+                    {
+                        in.value = -in.value;
+                    }
+                    break;
+                }
+            case OpCodes::Mul:
+                {
+                    in.value = code[in.childIndex].value;
+                    for (int j = 1; j < in.narg; ++j)
+                    {
+                        in.value *= code[in.childIndex + j].value;
+                    }
+                    break;
+                }
+            case OpCodes::Div:
+                {
+                    in.value = code[in.childIndex].value;
+                    for (int j = 1; j < in.narg; ++j)
+                    {
+                        in.value /= code[in.childIndex + j].value;
+                    }
+                    if (in.narg == 1)
+                    {
+                        in.value = 1 / in.value;
+                    }
+                    break;
+                }
+            case OpCodes::Exp:
+                {
+                    in.value = std::exp(code[in.childIndex].value);
+                    break;
+                }
+            case OpCodes::Log:
+                {
+                    in.value = std::log(code[in.childIndex].value);
+                    break;
+                }
+            case OpCodes::Sin:
+                {
+                    in.value = std::sin(code[in.childIndex].value);
+                    break;
+                }
+            case OpCodes::Cos:
+                {
+                    in.value = std::cos(code[in.childIndex].value);
+                    break;
+                }
+            case OpCodes::Tan:
+                {
+                    in.value = std::tan(code[in.childIndex].value);
+                    break;
+                }
+            case OpCodes::Power:
+                {
+                    double x = code[in.childIndex].value;
+                    double y = std::round(code[in.childIndex + 1].value);
+                    in.value = std::pow(x, y);
+                    break;
+                }
+            case OpCodes::Root:
+                {
+                    double x = code[in.childIndex].value;
+                    double y = std::round(code[in.childIndex + 1].value);
+                    in.value = std::pow(x, 1 / y);
+                    break;
+                }
+            case OpCodes::Sqrt:
+                {
+                    in.value = std::sqrt(code[in.childIndex].value);
+                    break;
+                }
+        }
+    }
+    return code[0].value;
+}
+
+inline void load_data(instruction &in, int* __restrict rows, int rowIndex, int batchSize) noexcept
+{
+    for (int i = 0; i < batchSize; ++i)
+    {
+        auto row = rows[rowIndex + i];
+        in.buf[i] = in.weight * in.data[row];
+    }
+}
+
+inline void evaluate(instruction* code, int len, int* __restrict rows, int rowIndex, int batchSize) noexcept
+{
+    for (int i = len - 1; i >= 0; --i)
+    {
+        instruction &in = code[i];
+        switch (in.opcode)
+        {
+            case OpCodes::Var:
+                {
+                    load_data(in, rows, rowIndex, batchSize); // buffer data
+                    break;
+                }
+            case OpCodes::Add:
+                {
+                    load(in.buf, code[in.childIndex].buf);
+                    for (int j = 1; j < in.narg; ++j)
+                    {
+                        add(in.buf, code[in.childIndex + j].buf);
+                    }
+                    break;
+                }
+            case OpCodes::Sub:
+                {
+                    if (in.narg == 1)
+                    {
+                        neg(in.buf, code[in.childIndex].buf);
+                        break;
+                    }
+                    else
+                    {
+                        load(in.buf, code[in.childIndex].buf);
+                        for (int j = 1; j < in.narg; ++j)
+                        {
+                            sub(in.buf, code[in.childIndex + j].buf);
+                        }
+                    }
+                    break;
+                }
+            case OpCodes::Mul:
+                {
+                    load(in.buf, code[in.childIndex].buf);
+                    for (int j = 1; j < in.narg; ++j)
+                    {
+                        mul(in.buf, code[in.childIndex + j].buf);
+                    }
+                    break;
+                }
+            case OpCodes::Div:
+                {
+                    if (in.narg == 1)
+                    {
+                        inv(in.buf, code[in.childIndex].buf);
+                        break;
+                    }
+                    else
+                    {
+                        load(in.buf, code[in.childIndex].buf);
+                        for (int j = 1; j < in.narg; ++j)
+                        {
+                            div(in.buf, code[in.childIndex + j].buf);
+                        }
+                    }
+                    break;
+                }
+            case OpCodes::Sin:
+                {
+                    sin(in.buf, code[in.childIndex].buf);
+                    break;
+                }
+            case OpCodes::Cos:
+                {
+                    cos(in.buf, code[in.childIndex].buf);
+                    break;
+                }
+            case OpCodes::Tan:
+                {
+                    tan(in.buf, code[in.childIndex].buf);
+                    break;
+                }
+            case OpCodes::Log:
+                {
+                    log(in.buf, code[in.childIndex].buf);
+                    break;
+                }
+            case OpCodes::Exp:
+                {
+                    exp(in.buf, code[in.childIndex].buf);
+                    break;
+                }
+            case OpCodes::Power:
+                {
+                    load(in.buf, code[in.childIndex].buf);
+                    pow(in.buf, code[in.childIndex + 1].buf);
+                    break;
+                }
+            case OpCodes::Root:
+                {
+                    load(in.buf, code[in.childIndex].buf);
+                    root(in.buf, code[in.childIndex + 1].buf);
+                    break;
+                }
+            case OpCodes::Square:
+                {
+                    square(in.buf, code[in.childIndex].buf);
+                    break;
+                }
+        }
+    }
+}
+
+#endif
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/vector_operations.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/vector_operations.h	(revision 16332)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/vector_operations.h	(revision 16332)
@@ -0,0 +1,75 @@
+#ifndef VECTOR_OPERATIONS_H
+#define VECTOR_OPERATIONS_H
+
+#define _USE_MATH_DEFINES
+#include <cmath>
+#include <cstring>
+
+#ifdef USE_VDT
+#include "vdt/vdtMath.h"
+#include "vdt/stdwrap.h"
+#define hl_exp vdt::fast_exp
+#define hl_log vdt::fast_log
+#define hl_sin vdt::fast_sin
+#define hl_cos vdt::fast_cos
+#define hl_tan vdt::fast_tan
+#define hl_sqrt vdt::fast_sqrt
+#define hl_pow vdt::fast_pow
+#define hl_round vdt::fast_round
+#else
+#define hl_exp std::exp
+#define hl_log std::log
+#define hl_sin std::sin
+#define hl_cos std::cos
+#define hl_tan std::tan
+#define hl_sqrt std::sqrt
+#define hl_pow std::pow
+#define hl_round std::round
+#endif
+
+constexpr int BATCHSIZE = 64;
+
+#define FOR(i) for(int i = 0; i < BATCHSIZE; ++i)
+
+// When auto-vectorizing without __restrict,
+// gcc and clang check for overlap (with a bunch of integer code)
+// before running the vectorized loop
+
+// vector - vector operations
+inline void load(double* __restrict a, double const * __restrict b) noexcept { std::memcpy(a, b, BATCHSIZE * sizeof(double)); }
+inline void add(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] += b[i]; }
+inline void sub(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] -= b[i]; }
+inline void mul(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] *= b[i]; }
+inline void div(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] /= b[i]; }
+inline void exp(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_exp(b[i]); }
+inline void log(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_log(b[i]); }
+inline void sin(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_sin(b[i]); }
+inline void cos(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_cos(b[i]); }
+inline void tan(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_tan(b[i]); }
+inline void sqrt(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_sqrt(b[i]); }
+inline void pow(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_pow(a[i], hl_round(b[i])); };
+inline void root(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_pow(a[i], 1. / hl_round(b[i])); };
+inline void square(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = hl_pow(b[i], 2.); };
+inline void inv(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = 1. / b[i]; }
+inline void neg(double* __restrict a, double const * __restrict b) noexcept { FOR(i) a[i] = -b[i]; }
+
+// vector - scalar operations
+inline void load(double* __restrict a, double s) noexcept { FOR(i) a[i] = s; }
+inline void add(double* __restrict a, double s) noexcept { FOR(i) a[i] += s; }
+inline void sub(double* __restrict a, double s) noexcept { FOR(i) a[i] -= s; }
+inline void mul(double* __restrict a, double s) noexcept { FOR(i) a[i] *= s; }
+inline void div(double* __restrict a, double s) noexcept { FOR(i) a[i] /= s; }
+
+// vector operations
+inline void neg(double* __restrict a) noexcept { FOR(i) a[i] = -a[i]; }
+inline void inv(double* __restrict a) noexcept { FOR(i) a[i] = 1. / a[i]; }
+inline void exp(double* __restrict a) noexcept { FOR(i) a[i] = hl_exp(a[i]); }
+inline void log(double* __restrict a) noexcept { FOR(i) a[i] = hl_log(a[i]); }
+inline void sin(double* __restrict a) noexcept { FOR(i) a[i] = hl_sin(a[i]); }
+inline void cos(double* __restrict a) noexcept { FOR(i) a[i] = hl_cos(a[i]); }
+inline void sqrt(double* __restrict a) noexcept { FOR(i) a[i] = hl_sqrt(a[i]); }
+inline void round(double* __restrict a) noexcept { FOR(i) a[i] = hl_round(a[i]); }
+inline void square(double* __restrict a) noexcept { FOR(i) a[i] = hl_pow(a[i], 2.); }
+
+#undef FOR
+#endif
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SymbolicClassificationModel.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SymbolicClassificationModel.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/SymbolicClassificationModel.cs	(revision 16332)
@@ -74,4 +74,16 @@
     }
 
+    public virtual bool IsProblemDataCompatible(IClassificationProblemData problemData, out string errorMessage) {
+      return ClassificationModel.IsProblemDataCompatible(this, problemData, out errorMessage);
+    }
+
+    public override bool IsProblemDataCompatible(IDataAnalysisProblemData problemData, out string errorMessage) {
+      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
+      var classificationProblemData = problemData as IClassificationProblemData;
+      if (classificationProblemData == null)
+        throw new ArgumentException("The problem data is not a regression problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      return IsProblemDataCompatible(classificationProblemData, out errorMessage);
+    }
+
     #region events
     public event EventHandler TargetVariableChanged;
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionModel.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionModel.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionModel.cs	(revision 16332)
@@ -83,4 +83,16 @@
     }
 
+    public virtual bool IsProblemDataCompatible(IRegressionProblemData problemData, out string errorMessage) {
+      return RegressionModel.IsProblemDataCompatible(this, problemData, out errorMessage);
+    }
+
+    public override bool IsProblemDataCompatible(IDataAnalysisProblemData problemData, out string errorMessage) {
+      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
+      var regressionProblemData = problemData as IRegressionProblemData;
+      if (regressionProblemData == null)
+        throw new ArgumentException("The problem data is not a regression problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      return IsProblemDataCompatible(regressionProblemData, out errorMessage);
+    }
+
     #region events
     public event EventHandler TargetVariableChanged;
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Plugin.cs.frame
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Plugin.cs.frame	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Plugin.cs.frame	(revision 16332)
@@ -42,5 +42,5 @@
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.MathJax", "1.1")]
+  [PluginDependency("HeuristicLab.MathJax", "1.2")]
   [PluginDependency("HeuristicLab.Optimization","3.3")]
   [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.4")]
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Trading/3.4/ProblemData.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Trading/3.4/ProblemData.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Trading/3.4/ProblemData.cs	(revision 16332)
@@ -1650,33 +1650,4 @@
       OnChanged();
     }
-
-    public override void AdjustProblemDataProperties(IDataAnalysisProblemData problemData) {
-      var data = problemData as ProblemData;
-      if (data == null) throw new ArgumentException("The problem data is not a problem data set for trading. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
-
-      string errorMessage;
-      if (!data.IsProblemDataCompatible(this, out errorMessage)) {
-        throw new InvalidOperationException(errorMessage);
-      }
-
-      base.AdjustProblemDataProperties(data);
-
-      var toDelete = PriceChangeVariableParameter.ValidValues.ToList();
-      foreach (var entry in data.PriceChangeVariableParameter.ValidValues) {
-        if (toDelete.Any(x => x.Value == entry.Value)) {
-          toDelete.RemoveAll(x => x.Value == entry.Value);
-        } else {
-          PriceChangeVariableParameter.ValidValues.Add(new StringValue(entry.Value));
-        }
-      }
-      PriceChangeVariableParameter.Value =
-        PriceChangeVariableParameter.ValidValues.Single(v => v.Value == data.PriceChangeVariable);
-
-      foreach (var varToDelete in toDelete) PriceChangeVariableParameter.ValidValues.Remove(varToDelete);
-
-      TransactionCostsParameter.Value.Value = data.TransactionCosts;
-
-      OnChanged();
-    }
   }
 }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Trading/3.4/Symbolic/Model.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Trading/3.4/Symbolic/Model.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Trading/3.4/Symbolic/Model.cs	(revision 16332)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -53,4 +54,10 @@
     }
 
+    public override bool IsProblemDataCompatible(IDataAnalysisProblemData problemData, out string errorMessage) {
+      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
+      return IsDatasetCompatible(problemData.Dataset, out errorMessage);
+    }
+
+
     // Transforms an enumerable of real values to an enumerable of trading signals (buy(1) / hold(0) / sell(-1))
     public static IEnumerable<double> GetSignals(IEnumerable<double> xs) {
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.cs	(revision 16332)
@@ -141,6 +141,4 @@
 
         var solution = (IDataAnalysisSolution)Content.Clone();
-        problemData.AdjustProblemDataProperties(solution.ProblemData);
-
         solution.ProblemData = problemData;
         if (!solution.Name.EndsWith(" with loaded problemData"))
@@ -231,5 +229,4 @@
 
       try {
-        problemData.AdjustProblemDataProperties(Content.ProblemData);
         Content.ProblemData = problemData;
 
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 16332)
@@ -167,4 +167,8 @@
       }
     }
+
+    public bool ContainsVariable(string variableName) {
+      return variableValues.ContainsKey(variableName);
+    }
     public IEnumerable<string> DoubleVariables {
       get { return variableValues.Where(p => p.Value is IList<double>).Select(p => p.Key); }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationModel.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationModel.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationModel.cs	(revision 16332)
@@ -66,4 +66,32 @@
     public abstract IClassificationSolution CreateClassificationSolution(IClassificationProblemData problemData);
 
+    public virtual bool IsProblemDataCompatible(IClassificationProblemData problemData, out string errorMessage) {
+      return IsProblemDataCompatible(this, problemData, out errorMessage);
+    }
+
+    public override bool IsProblemDataCompatible(IDataAnalysisProblemData problemData, out string errorMessage) {
+      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
+      var classificationProblemData = problemData as IClassificationProblemData;
+      if (classificationProblemData == null)
+        throw new ArgumentException("The problem data is not a regression problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      return IsProblemDataCompatible(classificationProblemData, out errorMessage);
+    }
+
+    public static bool IsProblemDataCompatible(IClassificationModel model, IClassificationProblemData problemData, out string errorMessage) {
+      if (model == null) throw new ArgumentNullException("model", "The provided model is null.");
+      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
+      errorMessage = string.Empty;
+
+      if (model.TargetVariable != problemData.TargetVariable)
+        errorMessage = string.Format("The target variable of the model {0} does not match the target variable of the problemData {1}.", model.TargetVariable, problemData.TargetVariable);
+
+      var evaluationErrorMessage = string.Empty;
+      var datasetCompatible = model.IsDatasetCompatible(problemData.Dataset, out evaluationErrorMessage);
+      if (!datasetCompatible)
+        errorMessage += evaluationErrorMessage;
+
+      return string.IsNullOrEmpty(errorMessage);
+    }
+
     #region events
     public event EventHandler TargetVariableChanged;
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblemData.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblemData.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationProblemData.cs	(revision 16332)
@@ -467,53 +467,4 @@
     }
     #endregion
-
-    protected override bool IsProblemDataCompatible(IDataAnalysisProblemData problemData, out string errorMessage) {
-      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
-      IClassificationProblemData classificationProblemData = problemData as IClassificationProblemData;
-      if (classificationProblemData == null)
-        throw new ArgumentException("The problem data is no classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
-
-      var returnValue = base.IsProblemDataCompatible(classificationProblemData, out errorMessage);
-      //check targetVariable
-      if (classificationProblemData.InputVariables.All(var => var.Value != TargetVariable)) {
-        errorMessage = string.Format("The target variable {0} is not present in the new problem data.", TargetVariable)
-                       + Environment.NewLine + errorMessage;
-        return false;
-      }
-
-      var newClassValues = classificationProblemData.Dataset.GetDoubleValues(TargetVariable).Distinct().OrderBy(x => x);
-      if (!newClassValues.SequenceEqual(ClassValues)) {
-        errorMessage = errorMessage + string.Format("The class values differ in the provided classification problem data.");
-        returnValue = false;
-      }
-
-      var newPositivieClassName = classificationProblemData.PositiveClass;
-      if (newPositivieClassName != PositiveClass) {
-        errorMessage = errorMessage + string.Format("The positive class differs in the provided classification problem data.");
-        returnValue = false;
-      }
-
-      return returnValue;
-    }
-
-    public override void AdjustProblemDataProperties(IDataAnalysisProblemData problemData) {
-      if (problemData == null) throw new ArgumentNullException("problemData", "The provided problemData is null.");
-      ClassificationProblemData classificationProblemData = problemData as ClassificationProblemData;
-      if (classificationProblemData == null)
-        throw new ArgumentException("The problem data is not a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
-
-      base.AdjustProblemDataProperties(problemData);
-      TargetVariable = classificationProblemData.TargetVariable;
-      for (int i = 0; i < classificationProblemData.ClassNames.Count(); i++)
-        ClassNamesParameter.Value[i, 0] = classificationProblemData.ClassNames.ElementAt(i);
-
-      PositiveClass = classificationProblemData.PositiveClass;
-
-      for (int i = 0; i < Classes; i++) {
-        for (int j = 0; j < Classes; j++) {
-          ClassificationPenaltiesParameter.Value[i, j] = classificationProblemData.GetClassificationPenalty(ClassValuesCache[i], ClassValuesCache[j]);
-        }
-      }
-    }
   }
 }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationSolutionBase.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationSolutionBase.cs	(revision 16331)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Classification/ClassificationSolutionBase.cs	(revision 16332)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -44,5 +45,11 @@
     public new IClassificationProblemData ProblemData {
       get { return (IClassificationProblemData)base.ProblemData; }
-      set { base.ProblemData = value; }
+      set {
+        if (value == null) throw new ArgumentNullException("The problemData must not be null.");
+        string errorMessage = string.Empty;
+        if (!Model.IsProblemDataCompatible(value, out errorMessage)) throw new ArgumentException(errorMessage);
+
+        base.ProblemData = value;
+      }
     }
 
